Subject: Re: [Netconf] xml start directive with ssh

From: Kent Watsen <[email-masked]>
Date: Wed, 7 Oct 2009 12:47:49 -0700

Wes Hardaker wrote:
> AB> I think the NETCONF subsystem should only send and receive
> AB> XML instance documents.  I would be surprised if any implementations
> AB> accepted arbitrary garbage text at any time.
> 
> I do agree that it would be a much cleaner service if we stop trying to
> do the odd protocol mashing.  If a bis is ever done I agree it should be
> dropped.

I don't see anything from this thread in the bis, should it be added now?

Also, is the consensus that the xml start directive MUST proceed <hello> and MAY proceed <rpc>, <rpc-reply>, and <notification>?

Thanks,
Kent

---

From: Andy Bierman <[email-masked]>
Date: Wed, 07 Oct 2009 13:09:23 -0700

>> AB> accepted arbitrary garbage text at any time.

This falls into the category of insane stuff
nobody is going to bother with, except somebody
writing a test to see if every little nit that
can be wrung out of the spec is followed.

Interoperability is achieved through common need.
The more complicated and less common the standard is,
the lower the interoperability will be.

> Also, is the consensus that the xml start directive MUST proceed <hello> and MAY proceed <rpc>, <rpc-reply>, and <notification>?

good catch -- probably a bug.
It makes no sense to deviate from XML 1.0
anywhere in the NETCONF protocol.  The XMLDecl
in the prolog is optional, so NETCONF is wrong.

> Kent

Andy

---

From: Martin Bjorklund <[email-masked]>
Date: Wed, 07 Oct 2009 22:15:46 +0200 (CEST)

> > I don't see anything from this thread in the bis, should it be added now?

This would be 4742bis, which we're not doing now.

> > Also, is the consensus that the xml start directive MUST proceed <hello> and
> > MAY proceed <rpc>, <rpc-reply>, and <notification>?
> > 
> 

Hmm... where?

> in the prolog is optional, so NETCONF is wrong.

We added the current clarification to 4741bis-01, section 3:

   A NETCONF message MAY begin with an XML declaration (see section 2.8
   of [1]).

which is consistent with XML.

/martin

---

From: Kent Watsen <[email-masked]>
Date: Wed, 7 Oct 2009 14:09:16 -0700

> which is consistent with XML.

Thanks!  So, even though there isn't a 4742bis, is it correct to assume that 4742's statement in section 3 regarding the XML declaration MUST precede the <hello> element is an error?

Thanks,
Kent

---

From: "Xiang Li" <[email-masked]>
Date: Wed, 7 Oct 2009 14:27:25 -0700 (PDT)

Looks to me it is a bug in RFC4742.

Xiang

"Kent Watsen" <[email-masked]> said:

> Thanks!  So, even though there isn't a 4742bis, is it correct to assume that
> 4742's statement in section 3 regarding the XML declaration MUST precede the
> <hello> element is an error?
> 
> Thanks,
> Kent
> 
> 
> 
> 
> _______________________________________________
> Netconf mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/netconf
>

---

From: Wes Hardaker <[email-masked]>
Date: Fri, 09 Oct 2009 09:12:37 -0700

>>>>> On Wed, 7 Oct 2009 14:27:25 -0700 (PDT), "Xiang Li" <[email-masked]> said:

XL> Looks to me it is a bug in RFC4742.

That's correct; it's not in the netconf protocol.  It's an SSH specific
transport issue.
-- 
Wes Hardaker
Cobham Analytic Solutions